#include <stdio.h>
#include <sys/io.h>
#include <errno.h>
#include <stdlib.h>


int IN_Port(
	unsigned long PortBase,
	unsigned int Portoffset,
	unsigned int *PortRegValue
	)
{
	int ret;

	ret = iopl(3);

	if (ret)
	{
		printf("ret = %d\n", ret);
		printf("errno = %d\n", errno);
		printf("error for iopl\n");
		exit(1);
	}

	*PortRegValue=inb(PortBase+Portoffset);

	return 1;
}

int Out_Port(
	unsigned long PortBase,
	unsigned int Portoffset,
	unsigned int PortRegValue
	)
{
	int rg,count;
	int ret;

	ret = iopl(3);

	if (ret)
	{
		printf("ret = %d\n", ret);
		printf("errno = %d\n", errno);
		printf("error for iopl\n");
		exit(1);
	}

	count=0;
	do
	{
		outb(PortRegValue,PortBase+Portoffset);
		rg=inb(PortBase+Portoffset);
		count++;
	} while(((rg != PortRegValue) && (count<10) ));

	if (count<10)
		return 1;
	else
		return 0;
}
